m4_define([_AX_CXX_COMPILE_STDCXX_11_testbody], [[
  template <typename T>
    struct check
    {
      static_assert(sizeof(int) <= sizeof(T), "not big enough");
    };

    struct Base {
    virtual void f() {}
    };
    struct Child : public Base {
    virtual void f() {}
    };

    typedef check<check<bool>> right_angle_brackets;

    int a;
    decltype(a) b;

    typedef check<int> check_type;
    check_type c;
    check_type&& cr = static_cast<check_type&&>(c);

    auto d = a;
    auto l = [](){};
]])

AC_DEFUN([AX_CXX_COMPILE_STDCXX_11], [dnl
   m4_if([$1], [], [],
         [$1], [ext], [],
         [$1], [noext], [],
         [m4_fatal([invalid argument `$1' to AX_CXX_COMPILE_STDCXX_11])])dnl
   m4_if([$2], [], [ax_cxx_compile_cxx11_required=true],
         [$2], [mandatory], [ax_cxx_compile_cxx11_required=true],
         [$2], [optional], [ax_cxx_compile_cxx11_required=false],
         [m4_fatal([invalid second argument `$2' to AX_CXX_COMPILE_STDCXX_11])])
   AC_LANG_PUSH([C++])dnl
   ac_success=no
   AC_CACHE_CHECK(whether $CXX supports C++11 features by default,
      ax_cv_cxx_compile_cxx11,
      [AC_COMPILE_IFELSE([AC_LANG_SOURCE([_AX_CXX_COMPILE_STDCXX_11_testbody])],
      [ax_cv_cxx_compile_cxx11=yes],
      [ax_cv_cxx_compile_cxx11=no])])

   if test x$ax_cv_cxx_compile_cxx11 = xyes; then
      ac_success=yes
   fi

   m4_if([$1], [noext], [], [dnl
      if test x$ac_success = xno; then
         for switch in -std=gnu++11 -std=gnu++0x -std=c++11 -std=c++0x; do
            cachevar=AS_TR_SH([ax_cv_cxx_compile_cxx11_$switch])
            AC_CACHE_CHECK(whether $CXX supports C++11 features with $switch,
            $cachevar,
            [ac_save_CXXFLAGS="$CXXFLAGS"
            CXXFLAGS="$CXXFLAGS $switch"
            AC_COMPILE_IFELSE([AC_LANG_SOURCE([_AX_CXX_COMPILE_STDCXX_11_testbody])],
            [eval $cachevar=yes],
            [eval $cachevar=no])
            CXXFLAGS="$ac_save_CXXFLAGS"])
            if eval test x\$$cachevar = xyes; then
               CXXFLAGS="$CXXFLAGS $switch"
               CXX11_SWITCH="$switch"
               AC_SUBST(CXX11_SWITCH)
               ac_success=yes
               break
            fi
         done
      fi])

   AC_LANG_POP([C++])

   if test x$ac_success = xno; then
      HAVE_CXX11=0
      AC_MSG_NOTICE([No compiler with C++11 support was found])
      AC_DEFINE(HAVE_CXX11,0,
         [define if the compiler supports basic C++11 syntax])
      if test x$ax_cxx_compile_cxx11_required = xtrue; then
         AC_MSG_ERROR([*** A compiler with support for C++11 language features is required.])
      fi
   else
      HAVE_CXX11=1
      AC_DEFINE(HAVE_CXX11,1,
         [define if the compiler supports basic C++11 syntax])
   fi
])
